Index: src/boundary.cpp
===================================================================
--- src/boundary.cpp	(revision 1ffa216657b5beb85210757a5d292a8b64bd5b79)
+++ src/boundary.cpp	(revision 69eb71ca95b6ddd8113c4c58130d3a649792ac26)
@@ -1250,38 +1272,45 @@
     }
 
-  Walker2 = *mol.start;
-
-  while (Walker2.nr != int(Storage[0]))
-    {
-      Walker = *Walker.next;
-    }
-  
-  helper.CopyVector(&Walker.x);
-  helper.SubtractVector(&Walker2.x);
+  Walker2 = mol->start;
+
+  while (Walker2->nr != int(Storage[0]))
+    {
+      Walker2 = Walker2->next;
+    }
+
+  helper.CopyVector(&(Walker->x));
+  helper.SubtractVector(&(Walker2->x));
   Oben.ProjectOntoPlane(&helper);
   helper.VectorProduct(&Oben);
-
-       Find_next_suitable_point(Walker, Walker2, *(mol.ListOfBondsPerAtom[Walker.nr][i]->leftatom->nr == Walker.nr ? mol.ListOfBondsPerAtom[Walker.nr][i]->rightatom : mol.ListOfBondsPerAtom[Walker.nr][i]->leftatom), 0, &helper, &Oben, Storage, RADIUS, mol);
-  Walker3 = *mol.start;
-  while (Walker3.nr != int(Storage[0]))
-    {
-      Walker3 = *Walker3.next;
+  Storage[0]=-1.;   // Id must be positive, we see should nothing be done
+  Storage[1]=-2.;   // This will contain the angle, which will be always positive (when looking for second point), when looking for third point this will be the quadrant.
+  Storage[2]= -10.;  // This will be an angle looking for the third point.
+
+  Chord.CopyVector(&(Walker->x)); // bring into calling function
+  Chord.SubtractVector(&(Walker2->x));
+
+printf("Looking for third point candidates \n");
+       Find_next_suitable_point(Walker, Walker2, (mol->ListOfBondsPerAtom[Walker->nr][0]->leftatom->nr == Walker->nr ? mol->ListOfBondsPerAtom[Walker->nr][0]->rightatom : mol->ListOfBondsPerAtom[Walker->nr][0]->leftatom), 0, &Chord, &helper, &Oben, Storage, RADIUS, mol);
+  Walker3 = mol->start;
+  while (Walker3->nr != int(Storage[0]))
+    {
+      Walker3 = Walker3->next;
     }
 
   //Starting Triangle is Walker, Walker2, index Storage[0]
 
-  AddPoint(&Walker);
-  AddPoint(&Walker2);
-  AddPoint(&Walker3);
-
-  BPS[0] = new class BoundaryPointSet(&Walker);
-  BPS[1] = new class BoundaryPointSet(&Walker2);
+  AddPoint(Walker);
+  AddPoint(Walker2);
+  AddPoint(Walker3);
+
+  BPS[0] = new class BoundaryPointSet(Walker);
+  BPS[1] = new class BoundaryPointSet(Walker2);
   BLS[0] = new class BoundaryLineSet(BPS , LinesOnBoundaryCount);
-  BPS[0] = new class BoundaryPointSet(&Walker);
-  BPS[1] = new class BoundaryPointSet(&Walker3);
+  BPS[0] = new class BoundaryPointSet(Walker);
+  BPS[1] = new class BoundaryPointSet(Walker3);
   BLS[1] = new class BoundaryLineSet(BPS , LinesOnBoundaryCount);
-  BPS[0] = new class BoundaryPointSet(&Walker);
-  BPS[1] = new class BoundaryPointSet(&Walker2);
-  BLS[2] = new class BoundaryLineSet(BPS , LinesOnBoundaryCount);  
+  BPS[0] = new class BoundaryPointSet(Walker);
+  BPS[1] = new class BoundaryPointSet(Walker2);
+  BLS[2] = new class BoundaryLineSet(BPS , LinesOnBoundaryCount);
 
   BTS = new class BoundaryTriangleSet(BLS, TrianglesOnBoundaryCount);
@@ -1289,5 +1318,5 @@
   TrianglesOnBoundaryCount++;
 
-  for(int i=0;i<NDIM;i++) 
+  for(int i=0;i<NDIM;i++)
     {
       LinesOnBoundary.insert( LinePair(LinesOnBoundaryCount, BTS->lines[i]) );
@@ -1304,14 +1333,14 @@
 
 
-void Find_non_convex_border(Tesselation* Tess, molecule mol) 
-{
+void Find_non_convex_border(Tesselation Tess, molecule* mol)
+{
+	printf("Entering finding of non convex hull. \n");
   const double RADIUS =6;
-  Tess->Find_starting_triangle(mol, RADIUS);
-
-  for (LineMap::iterator baseline = Tess->LinesOnBoundary.begin(); baseline != Tess->LinesOnBoundary.end(); baseline++) 
-    if (baseline->second->TrianglesCount == 1) 
+  Tess.Find_starting_triangle(mol, RADIUS);
+
+  for (LineMap::iterator baseline = Tess.LinesOnBoundary.begin(); baseline != Tess.LinesOnBoundary.end(); baseline++)
+    if (baseline->second->TrianglesCount == 1)
       {
-	Tess->Find_next_suitable_triangle(&mol, baseline->second, baseline->second->triangles.begin()->second, RADIUS); //the line is there, so there is a triangle, but only one.
-
+		Tess.Find_next_suitable_triangle(mol, *(baseline->second), *(baseline->second->triangles.begin()->second), RADIUS); //the line is there, so there is a triangle, but only one.
       }
     else
Index: src/boundary.hpp
===================================================================
--- src/boundary.hpp	(revision 1ffa216657b5beb85210757a5d292a8b64bd5b79)
+++ src/boundary.hpp	(revision 69eb71ca95b6ddd8113c4c58130d3a649792ac26)
@@ -82,5 +82,5 @@
     void GuessStartingTriangle(ofstream *out);
     void AddPoint(atom * Walker);
-    void Find_starting_triangle(molecule mol, const double RADIUS);
+    void Find_starting_triangle(molecule* mol, const double RADIUS);
     void Find_next_suitable_triangle(molecule* mol, BoundaryLineSet Line, BoundaryTriangleSet T, const double& RADIUS);
     
@@ -105,4 +105,6 @@
 double * GetDiametersOfCluster(ofstream *out, Boundaries *BoundaryPtr, molecule *mol, bool IsAngstroem);
 void PrepareClustersinWater(ofstream *out, config *configuration, molecule *mol, double ClusterVolume, double celldensity);
+void Find_next_suitable_point(atom a, atom b, atom Candidate, int n, Vector *d1, Vector *d2, double *Storage, const double RADIUS, molecule *mol);
+void Find_non_convex_border(Tesselation Tess, molecule* mol);
 
 
